// Rappel structure BMP
/*typedef struct tagBITMAPFILEHEADER { 
	WORD    bfType; 
	DWORD   bfSize; 
	WORD    bfReserved1; 
	WORD    bfReserved2; 
	DWORD   bfOffBits; 
} BITMAPFILEHEADER, *PBITMAPFILEHEADER; 

typedef struct tagBITMAPINFOHEADER{
	DWORD  biSize; 
	LONG   biWidth; 
	LONG   biHeight; 
	WORD   biPlanes; 
	WORD   biBitCount; 
	DWORD  biCompression; 
	DWORD  biSizeImage; 
	LONG   biXPelsPerMeter; 
	LONG   biYPelsPerMeter; 
	DWORD  biClrUsed; 
	DWORD  biClrImportant; 
} BITMAPINFOHEADER, *PBITMAPINFOHEADER; 
*/

char* LoadFileBmp (char *szFileName, int *width, int *height)
{
	int hFile;

	char bmpHeader[14];
	int NbByteRead;
	char* lpcAdressBmp;

	char* lpcTamponLecture, *lpcTexture;
	char* lpcTamponTrt, *lpcTextureTrt;
	int i, j;
	int biWidth, biHeight;

	hFile = open (szFileName, O_RDONLY,0666);

	if (hFile > 0)
	{	
		lpcAdressBmp = 0;
		// Lecture de l'ent�e du fichier
		NbByteRead = read (hFile, &bmpHeader, 14);
		// Test le nombre d'octets lu
		if (NbByteRead == 14)
		{
			if (memcmp (&bmpHeader, "BM", 2) == 0)
			{
				// Ok, il s'agit bien d'un BMP, lecture BITMAPINFOHEADER
				unsigned char infoHeader[40];

				NbByteRead = read (hFile, infoHeader, 40); // Vérification en-tête
				if (NbByteRead == 40)
				{
					biWidth = ((infoHeader[5]<<8) + infoHeader[4]) + (((infoHeader[7]<<8) + infoHeader[6])<<16);
					biHeight = (infoHeader[8] + (infoHeader[9]<<8)) + ((infoHeader[10] + ( infoHeader[11]<<8))<<16);

					// On ne va lire que les images sur 24 bits, pour les autres formats, revoyez le code !
					if (/*infoHeader.biPlanes*/ infoHeader[12] + (infoHeader[13]<<8) != 1 || /*infoHeader.biBitCount*/ infoHeader[14] + (infoHeader[15]<<8) == 24)
					{
						if (biWidth <= 2048 && biHeight <= 2048)
						{
							lpcTamponLecture = (char *)malloc (biWidth * biHeight * 3);
							lpcTexture = (char *)malloc (biWidth * biHeight * 4);

							if (lpcTamponLecture != 0 && lpcTexture != 0)
							{
								// On se positionne sur le d�ut du fichier pour ce d�lacer sur le d�ut de l'image ensuite !
								lseek(hFile, (bmpHeader[10] + (bmpHeader[11]<<8)) + (bmpHeader[12] + (bmpHeader[13]<<8)<<16), SEEK_SET);
								
								*width = biWidth;
								*height = biHeight;

								// Maintenant que nous sommes sur l'image, lecture de celle-ci
								NbByteRead = read(hFile, lpcTamponLecture, biWidth * biHeight * 3);
								if (NbByteRead == biWidth * biHeight * 3)
								{
									// Convertir l'image BVR en RVBA
									lpcTextureTrt = lpcTexture;
									lpcTamponTrt = lpcTamponLecture;
									
									for (i=0; i < biHeight * biWidth; i++)
									{
										*lpcTextureTrt = *(lpcTamponTrt + 2);
										*(lpcTextureTrt+1) = *(lpcTamponTrt + 1);
										*(lpcTextureTrt+2) = *(lpcTamponTrt);
										*(lpcTextureTrt+3) = 255;
										lpcTextureTrt+=4;
										lpcTamponTrt+=3;
									}
									lpcAdressBmp = lpcTexture;
								}
								else
								{
									free (lpcTexture);
								}
							}
							else
								if (lpcTexture != 0)
									free (lpcTexture);
							free (lpcTamponLecture);
						}
					}
				}
			}
			else
				printf ("Erreur !\n");
		}			

		close(hFile);
		return lpcAdressBmp;
	}
	else
		return 0;
}

